/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package performance;

import java.io.FileOutputStream;
import java.io.FileReader;
import java.io.IOException;
import java.util.StringTokenizer;

/**
 *
 * @author yunglu
 */
public class Matrix {

    double[][] elements;

    public Matrix(int row, int col) {
        elements = new double[row][col];
    }

    public static Matrix random(int row, int col) {
        Matrix AM = new Matrix(row, col);
        for (int rindex = 0; rindex < AM.elements.length;
                rindex++) {
            for (int cindex = 0; cindex < AM.elements[0].length;
                    cindex++) {
                AM.elements[rindex][cindex] =
                        Math.random() * 1000 - 500;
            }
        }
        return AM;
    }

    public static Matrix identity(int row) {
        Matrix AM = new Matrix(row, row);
        for (int rindex = 0; rindex < AM.elements.length;
                rindex++) {
            for (int cindex = 0; cindex < AM.elements[0].length;
                    cindex++) {
                if (rindex == cindex) {
                    AM.elements[rindex][cindex] = 1;
                } else {
                    AM.elements[rindex][cindex] = 0;
                }
            }
        }
        return AM;
    }

    public Matrix transpose() {
        Matrix AM = new Matrix(elements[0].length,
                elements.length);
        for (int rindex = 0; rindex < AM.elements.length;
                rindex++) {
            for (int cindex = 0; cindex < AM.elements[0].length;
                    cindex++) {
                AM.elements[rindex][cindex] =
                        elements[cindex][rindex];
            }
        }
        return AM;
    }

    public Matrix add(Matrix BM) {
        return addSubtract(BM, 1);
    }

    public Matrix subtract(Matrix BM) {
        return addSubtract(BM, -1);
    }

    private Matrix addSubtract(Matrix BM, int p) {
        Matrix CM;
        if ((elements.length != BM.elements.length) ||
                (elements[0].length != BM.elements[0].length)) {
            System.out.println("plus different dimensions");
            CM = Matrix.random(elements.length,
                    elements[0].length);
        } else {
            CM = new Matrix(elements.length,
                    elements[0].length);
            for (int rindex = 0; rindex < elements.length;
                    rindex++) {
                for (int cindex = 0; cindex < elements[0].length;
                        cindex++) {
                    CM.elements[rindex][cindex] =
                            elements[rindex][cindex] +
                            (p * BM.elements[rindex][cindex]);
                }
            }
        }
        return CM;
    }

    public void print() {
        System.out.println("row, column = " +
                elements.length + " " +
                elements[0].length);
        for (int rindex = 0; rindex < elements.length;
                rindex++) {
            for (int cindex = 0; cindex < elements[0].length;
                    cindex++) {
                System.out.format("%10.3f", elements[rindex][cindex]);
            }
            System.out.println();
        }
    }

    public void write(String fileName) {
        try {
            String sout = String.format("%d %d",
                    elements.length,
                    elements[0].length);
            for (int rindex = 0; rindex < elements.length;
                    rindex++) {
                for (int cindex = 0; cindex < elements[0].length;
                        cindex++) {
                    sout += String.format(" %f", elements[rindex][cindex]);
                }
            }
            FileOutputStream fos = new FileOutputStream(fileName);
            fos.write(sout.getBytes());
            fos.close();
        } catch (IOException ioe) {
            System.out.println("IOException in write");
        }
    }

    public static Matrix read(String fileName) {
        Matrix CM = new Matrix(0, 0);
        try {
            FileReader frd = new FileReader(fileName);
            // read the whole file
            int ch;
            String sin = "";
            while ((ch = frd.read()) != -1) {
                sin += (char) ch;
            }
            StringTokenizer stk = new StringTokenizer(sin);
            int row = Integer.parseInt(stk.nextToken());
            int col = Integer.parseInt(stk.nextToken());
            CM = new Matrix(row, col);
            int numElement = row * col;
            int rindex = 0;
            int cindex = 0;
            while ((numElement > 0) && (stk.hasMoreTokens())) {
                CM.elements[rindex][cindex] = 
                        Double.parseDouble(stk.nextToken());
                cindex ++;
                if (cindex >= col) {
                    cindex = 0;
                    rindex ++;
                }
                numElement--;
            }
            if (numElement > 0) {
                System.out.println("Insufficient elements in read");
            }
            if (stk.hasMoreTokens()) {
                System.out.println("Too many elements in read");
            }
        } catch (IOException ioe) {
            System.out.println("IOException in read");
        }
        return CM;
    }
}
